/* make sum file from Inn */
/*	(C) taka@exsys.prm.prug.or.jp */
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <unistd.h>

#define	OUT_DIR		"out.going"
#define	SUM_FILE	"sum"

#define	LINELEN		1024

struct FROM_TABLE {
	struct FROM_TABLE	*next;	/* next pointer */
	int			size;	/* size */
	int			cnt;
	char			*from;	/* news from */
};
struct NG_TABLE {
	struct NG_TABLE		*next;	/* next pointer */
	struct FROM_TABLE	*from;	/* from table pointer */
	int			size;	/* size */
	int			cnt;
	char			*ng;	/* newsgroup */
};
#define	NULLFROM	(struct FROM_TABLE *)0
#define	NULLTABLE	(struct NG_TABLE *)0

static struct NG_TABLE	*Table = NULLTABLE;

struct FROM_TABLE *
make_from(size, from)
int	size;
char	*from;
{
struct FROM_TABLE	*fp;
	fp = (struct FROM_TABLE *)malloc(sizeof(struct FROM_TABLE));
	fp->next = NULLFROM;
	fp->size = size;
	fp->cnt = 1;
	fp->from = strdup(from);

	return fp;
}

struct NG_TABLE *
make_table(size, ng, from)
int	size;
char	*ng;
char	*from;
{
struct NG_TABLE	*np;
	np = (struct NG_TABLE *)malloc(sizeof(struct NG_TABLE));
	np->next = NULLTABLE;
	np->from = make_from(size, from);
	np->size = size;
	np->cnt = 1;
	np->ng = strdup(ng);

	return np;
}

add_from(fp, size, from)
struct FROM_TABLE	**fp;
int	size;
char	*from;
{
struct FROM_TABLE	*p;
struct FROM_TABLE	**p1;
int	i;
	for (p = *fp, p1 = fp; p != NULLFROM; p1 = &(p->next),p = p->next) {
		i = strcmp(p->from, from);
		if (i == 0) {
			/* hit */
			p->size += size;
			p->cnt++;
			return;
		}
		else if (i > 0) {
			/* new table */
			*p1 = make_from(size, from);
			(*p1)->next = p;
			return;
		}
	}
	*p1 = make_from(size, from);
}

add_table(size, ng, from)
int	size;
char	*ng;
char	*from;
{
struct NG_TABLE	*p;
struct NG_TABLE	**p1;
int	i;
	for(p = Table, p1 = &Table; p != NULLTABLE;
			p1 = &(p->next),p = p->next) {
		i = strcmp(p->ng, ng);
		if (i == 0) {
			p->size += size;
			p->cnt++;
			add_from(&(p->from), size, from);
			return;
		}
		else if (i > 0) {
			*p1 = make_table(size, ng,from);
			(*p1)->next = p;
			return;
		}
	}
	*p1 = make_table(size, ng, from);
}

rip(s)
char	*s;
{
char	*p;
	if ((p = strrchr(s, '\n')) != NULL)
		*p = 0;
}

adding(size, from, ngs)
int	size;
char	*from;
char	*ngs;
{
char	*p;
char	ng[LINELEN];
char	*p1;
	p = ngs;
	p1 = ng;
	while(*p) {
		if (*p == ',') {
			++p;
			continue;
		}
		if (*p == '.') {
			*p1 = 0;
			if (strcmp(ng, "to") != 0)
				add_table(size, ng, from);
			p1 = ng;
			while(*p != ',' && *p != 0)
				++p;
		}
		else {
			*p1++ = *p;
			++p;
		}
	}
}

display()
{
struct NG_TABLE		*np;
struct FROM_TABLE	*fp;
char	cnt[30];
char	size[30];
int	total;
int	count;
	total = count = 0;
	printf("\n");
	fflush(stdout);
	system("date");
	fflush(stdout);
	printf("\n");
	printf("Topgroup    Route   Count           Byte\n");
	printf("----------------------------------------\n");
	for(np = Table; np != NULLTABLE; np = np->next) {
		printf("%-17s %7d  %13d\n",
				np->ng, np->cnt, np->size);
		count += np->cnt;
		total += np->size;
		for(fp = np->from; fp != NULLFROM; fp = fp->next) {
			sprintf(cnt, "%d/%d", fp->cnt, np->cnt);
			sprintf(size, "%d/%d", fp->size, np->size);
			printf("%17s %7s  %13s\n",
				 	fp->from, cnt, size);
		}
	}
	printf("----------------------------------------\n");
	printf("Total             %7d  %13d\n", count, total);
}

main(argc, argv)
int	argc;
char	**argv;
{
FILE	*fp;
char	site[80];
char	fname[LINELEN];
char	buf[LINELEN];
int	size;
char	from[40];
char	ngs[LINELEN];
int	mode;
	/* sum file */
	if (argc > 1) {
		strcpy(site, argv[1]);
	}
	else {
		strcpy(site, SUM_FILE);
	}
	/* check sum file */
	sprintf(buf, "%s/%s/%s", NEWS_DIR, OUT_DIR, site);
	if (access(buf, R_OK) != 0) {
		fprintf(stderr, "%s: <%s> not found\n", argv[0], buf);
		exit(0);
	}
	if (access(buf, W_OK) == 0) {
		/* rename & flush */
		sprintf(buf, "mv %s/%s/%s %s/%s/%s.work",
			NEWS_DIR, OUT_DIR, site, 
			NEWS_DIR, OUT_DIR, site);
		system(buf);
		sprintf(buf, "%s/ctlinnd -s -t30 flush %s", NEWSBIN, site);
		system(buf);
		/* sum make */
		sprintf(fname, "%s/%s/%s.work", NEWS_DIR, OUT_DIR, site);
		mode = 1;
	}
	else {
		sprintf(fname, "%s/%s/%s", NEWS_DIR, OUT_DIR, site);
		mode = 0;
	}
	if ((fp = fopen(fname, "r")) == NULL) {
		fprintf(stderr, "%s: <%s> open error\n", argv[0], fname);
		exit(0);
	}
	while(fgets(buf, LINELEN, fp) != NULL) {
		rip(buf);
		sscanf(buf, "%d %s %[^\n]\n", &size, from, ngs);
		adding(size, from, ngs);
	}
	fclose(fp);
	if (mode)
		unlink(fname);
	display();
}



