/* ka9q mailer
	by taka@exsys.prm.prug.or.jp (JF2CEX)
*/

#include <stdio.h>
#include <fcntl.h>
#ifndef	USE_GETHNAME
#include <sys/utsname.h>
#endif
#include "defs.h"
#include "mailcf.h"
#include "sendmail.h"

char *myprg;
char *mailcf = MAILCF_FILE;
char *bbsuserfile = BBSUSER_FILE;

struct gateway *conv_list();

/* reading mail to file. from stdin */
static FILE *
read_mail()
{
FILE	*fp;
char	buf[LINELEN];
	if ((fp = tmpfile()) == NULLFILE) {
		fprintf(stderr, "tmpfile error\n");
		exit(-1);
	}
	while(fgets(buf, LINELEN, stdin) != NULL)
		fputs(buf, fp);
	return(fp);
}

main(argc,argv)
int argc;
char **argv;
{
char *from;
char *host;
char **av;
char **av1;
char *p;
struct list *tolist = NULLLIST;
struct gateway	*gp, *gtop;
struct address *ap;
FILE	*fp;
int	flag = 0;
#ifndef	USE_GETHNAME
struct utsname ho;
#else
char	hname[64];
#endif
	umask(077);
	myprg = argv[0];
	from = host = NULL;
	av = argv;
	while((p = *++av) != NULL) {
		if (*p++ != '-')
			break;
		switch(*p++) {
			case 'f' :
			case 'r' :
				/* from */
				if (*p == 0) {
					if ((p = *++av) == NULL) {
						--av;
						break;
					}
				}
				from = p;
				break;
			case 'h' :
				/* host */
				if (*p == 0) {
					if ((p = *++av) == NULL) {
						--av;
						break;
					}
				}
				host = p;
				break;
		}
	}
	if (host == NULL) {	/* V1.1.1 */
#ifndef	USE_GETHNAME
		uname(&ho);
		host = ho.nodename;
#else
		gethostname(hname, 64);
		host = hname;
#endif
	}
	if (from == NULL) {
		fprintf(stderr,"%s: no from\n",myprg);
		exit(-1);
	}
	if (*av == NULL) {
		fprintf(stderr,"%s: no to\n",myprg);
		exit(-1);
	}
	fp = read_mail();	/* read and queue mail text */
	for(av1 = av; *av1; ++av1) {
		if (sendmail(&tolist, *av1) <= BADADDR) {
			/* bad address. old type */
			mailsend(fp,av,host,from,NULL);
			fclose(fp);
			exit(0);
		}
		if (flag == 0) {
			if (mailhost(host) != LOCAL) {
				/* host is other. old type */
				mailsend(fp,av,host,from,NULL);
				fclose(fp);
				exit(0);
			}
			++flag;
		}
	}
	gtop = conv_list(tolist);
	for (gp = gtop; gp; gp = gp->next) {
		if (gp->name != NULL && gp->mailer == MAIL_SMTP) {
			/* smtp */
			mailsend(fp, NULL, gp->name, from, gp->addr);
		}
		else {
			/* local & rmail */
			mailsend(fp, NULL, host, from, gp->addr);
		}
	}
	fclose(fp);
	exit(0);
}

mailsend(fin,to,host,from,add)
FILE	*fin;
char **to;
char *host;
char *from;
struct address *add;
{
int no;
char buf[LINELEN];
char fnam[LINELEN];
int fd;
FILE *fp;
long get_msgid();
char	**av;
struct address *ap;
	no = get_msgid();
	/* make lock file */
	sprintf(fnam,"%s/%d.lck",MQUEUE_DIR,no);
	if ((fd = open(fnam, O_WRONLY | O_EXCL | O_CREAT)) < 0) {
		fprintf(stderr,"%s: %s creat error\n",myprg,fnam);
		exit(-1);
	}
	close(fd);
	/* make text file */
	umask(077);	/* V1.1.2 */
	sprintf(buf,"%s/%d.txt",MQUEUE_DIR,no);
	if ((fp = fopen(buf,"w")) == NULL) {
		fprintf(stderr,"%s: %s open error\n",myprg,buf);
		exit(-1);
	}
	umask(022);	/* V1.1.2 */
	/* copy text */
	fseek(fin, 0L,0);
	while(fgets(buf,LINELEN,fin) != NULL)
		fputs(buf,fp);
	fclose(fp);
	/* make wrk file */
	sprintf(buf,"%s/%d.wrk",MQUEUE_DIR,no);
	if ((fp = fopen(buf,"w")) == NULL) {
		fprintf(stderr,"%s: %s open error\n",myprg,buf);
		exit(-1);
	}
	fprintf(fp,"%s\n",host);
	fprintf(fp,"%s\n",from);
	if (to != NULL) {
		/* old type. char **to */
		for (av = to; *av; ++av)
			fprintf(fp,"%s\n",*av);
	}
	else {
		/* new type. struct address *add */
		for(ap = add; ap; ap = ap->next)
			fprintf(fp, "%s\n", ap->name);
	}
	fclose(fp);
	/* unlink lock */
	unlink(fnam);
}

long
get_msgid()
{
char buf[LINELEN];
char fnam[LINELEN];
char fn[LINELEN];
FILE *fp;
int fd;
long seq = 0;
	/* wait locking */
	sprintf(fnam,"%s/sequence.lck",MQUEUE_DIR);
	while((fd = open(fnam, O_WRONLY | O_CREAT | O_EXCL, 0666)) == -1)
		sleep(1);
	close(fd);
	/* get msg id */
	sprintf(fn,"%s/sequence.seq",MQUEUE_DIR);
	if ((fp = fopen(fn,"r")) != NULL) {
		fgets(buf,LINELEN,fp);
		seq = atol(buf);
		fclose(fp);
	}
	/* update seq */
	fp = fopen(fn,"w");
	fprintf(fp,"%d\n",++seq);
	fclose(fp);
	/* unlink lock */
	unlink(fnam);

	return(seq);
}


