/*	mailcf.c
	mail routing subroutine
	by taka@exsys.prm.prug.or.jp */

/* for oimo */
#ifdef	OIMO
#	define	SENDMAIL
#	define	STANDALONE
#endif
/* for mailtest */
#ifdef	MAILTEST
#	define	SENDMAIL
#	define	STANDALONE
#endif
/* for ka9qmailer */
#ifdef	KA9QMAIL
#	define	UNIX
#	define	SENDMAIL
#	define	STANDALONE
#	define	RMAIL
#	define	UUCP
#endif


#ifndef	STANDALONE
#include "global.h"
#endif

#ifdef	SENDMAIL

#include <stdio.h>

#include <string.h>

#ifdef	STANDALONE
#ifndef	NEXT
#	include <malloc.h>
#endif
#include "mailcf.h"
#include "sendmail.h"

void	del_list();
static void	rip();

#else

#include "smtp.h"
#endif

/*
#define	DEBUG
*/

#ifndef UNIX
static void sm_addlist(struct list **head, char *add);
static void sm_host(struct list **head, char *new, char *old);
static void sm_route(struct list **head, char *host, char *mailer,char *domain);
static int sm_alias(struct list **head, char *add);
static int mailhost(char *dest);
static int sm_chkdom(char *s1, char *s2);
#else
static void sm_addlist();
static void sm_host();
static void sm_route();
static int sm_alias();
#ifndef KA9QMAIL
static int mailhost();
#endif
static int sm_chkdom();
#endif

extern char	*mailcf;	/* mail.cf filename. from netdef */
extern char	*bbsuserfile;	/* bbs users file */
struct MYDOM {
	struct MYDOM	*next;
	char	*domain;
};
#define	NULL_MYDOM	(struct MYDOM *)0
static struct MYDOM	*myhost = NULL_MYDOM;

char	*topdomain = NULL;

static void my_domains(nam)
char	*nam;
{
struct MYDOM *mp;
char	*p;
	p = (char *)net_malloc(strlen(nam)+1);
	strcpy(p, nam);
	mp = (struct MYDOM *)net_malloc(sizeof(struct MYDOM));
	mp->next = myhost;
	mp->domain = p;
	myhost = mp;
#ifdef	DEBUG
	printf("my domain <%s>\n", nam);
#endif
}

static void free_mydom()
{
struct MYDOM *mp, *mp1;
	for (mp = myhost; mp != NULL_MYDOM; mp = mp1) {
		mp1 = mp->next;
		if (mp->domain != NULL)
			net_free(mp->domain);
		net_free(mp);
	}
}

int
sendmail(head, user)
struct list **head;
char	*user;
{
FILE	*fp;
char	s1[LINELEN];
char	s2[LINELEN];
char	s3[LINELEN];
char	buf[LINELEN];
char	gateway[LINELEN];
char	state;
struct list *tp;
int	hit;
int err;
struct list *tp1, *tp2;
#ifdef	DEBUG
	printf("request: <%s>\n", user);
#endif
	if ((fp = fopen(mailcf, "rt")) == NULLFILE) {
		/* nothing mail.cf */
#ifdef	DEBUG
		printf("Error: %s not found\n", mailcf);
#endif
		return BADADDR;
	}
	/* get my domain */
	state = 0;
	myhost = NULL_MYDOM;
	gateway[0] = 0;
	if (topdomain) {
		net_free(topdomain);
		topdomain = NULL;
	}
	while(fgets(buf,LINELEN,fp) != 0) {
		rip(buf);
		switch (buf[0]) {
			case 'J' :	/* routing */
				state = 0;
				if (sscanf(buf, "J %[^ :]%*c %s %s",
						s1,s2,s3) == 3) {
					if (strcmp(s2, "local") == 0) {
						/* local domain name */
						my_domains(s1);
						my_domains(s3);
						state = 'J';
					}
					else if (strcmp(s2, "gateway") == 0) {
						/* gateway host name */
						strcpy(gateway, s1);
#ifdef	DEBUG
						printf("gateway <%s>\n",s1);
#endif
					}
				}
				break;
			case ' ' :
			case '\t' :
				if (state == 'J') {
					if (sscanf(buf, " %s", s3) == 1)
						my_domains(s3);
				}
				break;
			case 'G' :	/* gateway CEX921225 */
				if (sscanf(buf, "G %[^ :]", s1) == 1) {
					strcpy(gateway, s1);
#ifdef	DEBUG
					printf("gateway <%s>\n",s1);
#endif
				}
				break;
			case '#' :	/* remak */
				break;
			case 'T' :	/* Topdomain CEX940618 */
				if (sscanf(buf, "T %[^ :]", s1) == 1) {
					topdomain = net_strdup(s1);
					my_domains(s1);
#ifdef	DEBUG
					printf("top domain <%s>\n",topdomain);
#endif
				}
				break;
			default :
				state = 0;
		}
	}
	fseek(fp, 0L, 0);
	/* mail.cf process */
	sm_addlist(head, user);	/* initialize header */
	/* first process. H & A */
	state = 0;
	while(fgets(buf,LINELEN,fp) != 0) {
		rip(buf);
		switch(buf[0]) {
			case 'H' :	/* host aliases */
				state = 0;
				if (sscanf(buf,"H %[^ :]%*c %s", s1, s2) == 2) {
					sm_host(head, s1, s2);
					state = 'H';
				}
				break;
			case 'A' :	/* aliases */
				state = 0;
				if (sscanf(buf, "A %[^ :]%*c %s",s1, s2) == 2) {
					if (sm_alias(head,s1) != 0) {
						sm_addlist(head, s2);
						state = 'A';
					}
				}
				break;
			case 'J' :	/* host route */
				state = 0;
				if (sscanf(buf, "J %[^ :]%*c %s %s",
						s1,s2,s3) == 3) {
					if (strcmp(s2, "local") != 0) {
						sm_route(head, s1, s2, s3);
						state = 'J';
					}
				}
				break;
			case ' ' :
			case '\t' :
				switch(state) {
					case 'H' :	/* host aliases */
						if (sscanf(buf," %s",s2) == 1)
							sm_host(head,s1,s2);
						break;
					case 'A' :	/* aliases */
						if (sscanf(buf, " %s",s2) == 1)
							sm_addlist(head,s2);
						break;
					case 'J' :	/* host route */
						if (sscanf(buf, " %s", s3) == 1)
							sm_route(head,s1,s2,s3);
						break;
				}
				break;
			case '#' :
				break;
			default :
				state = 0;
		}
	}
	fclose(fp);
	/* check address */
	for (tp = *head; tp != NULLLIST; tp = tp->next) {
		/* set gateway */
		if (tp->type == BADADDR) {
			if (tp->host != NULL) {
				net_free(tp->host);
				tp->host = NULL;
			}
			/* check top domain */
			if (topdomain &&
					sm_chkdom(tp->val, topdomain) > 0) {
				tp->type = NODOMAIN;
#ifdef	DEBUG
				printf("nodomain <%s>\n", tp->val);
#endif
				continue;
			}
			if (gateway[0] != 0) {
				if (mailhost(gateway) != 0) {
					tp->host = (char *)net_malloc(
						strlen(gateway)+1);
					strcpy(tp->host, gateway);
					tp->type = DOMAIN;
#ifdef	DEBUG
					printf("set gateway <%s>\n",gateway);
#endif
				}
				else {
					tp->type = LOCAL;
#ifdef	DEBUG
					printf("gateway error <%s>\n",gateway);
#endif
				}
			}
		}
		/* check local user */
		if (tp->type == LOCAL) {
			if (tp->host != NULL) {
				net_free(tp->host);
				tp->host = NULL;
			}
			/* check local user */
			if (strcmp("rnews", tp->val) != 0) {
				if ((fp = fopen(bbsuserfile,"rb")) != NULL) {
					hit = 0;
					while(fgets(buf,20,fp) != NULL) {
						rip(buf);
						if (strcmp(buf, tp->val) == 0) {
							hit = 1;
							break;
						}
					}
					fclose(fp);
					if (hit == 0) {
						tp->type = NOUSER;
#ifdef	DEBUG
						printf("no user <%s>\n",
							tp->val);
#endif
					}
				}
			}
		}
	}
	/* free mydomain */
	free_mydom();
	/* check BADADDR */
	err = 1;
	for (tp = *head; tp != NULLLIST; ) {
		tp->dom = 256;
		if (tp->type <= BADADDR) {
			tp2 = tp->next;
			err = tp->type;
			if (tp == *head)
				*head = tp2;
			else
				tp1->next = tp2;
			net_free(tp);
			tp = tp2;
			continue;
		}
		tp1 = tp;
		tp = tp->next;
	}
	return err;
}

static int
trim_mydom(p)
char	*p;
{
char	*cp;
	while(1) {
		/* nothing '@' is LOCAL */
		if ((cp = strrchr(p, '@')) == NULL)
			return LOCAL;
		++cp;
		if (mailhost(cp) == LOCAL) {
			/* my domain. delete it */
			*(cp-1) = 0;
			/* replase '%' -> '@' */
			if ((cp = strrchr(p, '%')) != NULL)
				*cp = '@';
		}
		else
			return DOMAIN;
	}
}

/* add list */
static void
sm_addlist(head, add)
struct list **head;
char *add;
{
struct list *tp;
int	type;
int	tn;
	type = BADADDR;
	if (trim_mydom(add) == LOCAL)
		type = LOCAL;

	tp = (struct list *)net_calloc(1,sizeof(struct list));
	tp->next = NULLLIST;
	tp->val = (char *)net_malloc(strlen(add)+1);
	strcpy(tp->val, add);
	tp->type = type;
	tp->dom = 0;
	tp->mailer = MAIL_SMTP;
	if (type != LOCAL && topdomain &&
			(tn = sm_chkdom(add, topdomain)) > 0) {
		tp->type = NODOMAIN;
		tp->dom = tn;
#ifdef	DEBUG
		printf("master process <%s> %d\n", add,n);
#endif
	}
#ifdef	DEBUG
	printf("add list <%s>\n",tp->val);
#endif

	if (*head == NULLLIST)
		*head = tp;
	else {
		tp->next = *head;
		*head = tp;
	}
}

/* search to.. and delete it */
static int
sm_alias(head, add)
struct list **head;
char *add;
{
struct list *tp;
struct list *tp1;
	for(tp = *head; tp != NULLLIST; tp1 = tp, tp = tp->next) {
		if (tp->dom == 256)
			continue;
		if (strcmp(tp->val,add) == 0) {
#ifdef	DEBUG
			printf("alias <%s>\n", add);
#endif
			if (tp == *head)
				*head = tp->next;
			else
				tp1->next = tp->next;
			if (tp->val != NULL)
				net_free(tp->val);
			if (tp->host != NULL)
				net_free(tp->host);
			net_free(tp);
			return 1;
		}
	}
	return 0;
}

/* replace host */
static void
sm_host(head, new, old)
struct list **head;
char	*new, *old;
{
struct list *tp;
int	nl;
char	*p;
char	*p1;
	if (*head == NULLLIST)
		return;
	for(tp = *head; tp != NULLLIST; tp = tp->next) {
		if (tp->dom == 256)
			continue;
		if ((p = strrchr(tp->val, '@')) == NULL)
			continue;
		++p;
		if (strcmp(p, old) == 0) {
#ifdef DEBUG
			printf("Host alias <%s> ",tp->val);
#endif
			if (mailhost(new) == LOCAL) {
				*(p-1) = 0;
				if ((p = strrchr(tp->val, '%')) != NULL)
					*p = '@';
				if (trim_mydom(tp->val) == LOCAL)
					tp->type = LOCAL;
				p1 = (char *)net_malloc(strlen(tp->val)+1);
				strcpy(p1, tp->val);
			}
			else {
				if (strchr(new, '@') != NULL) {
					*(p-1) = '%';
				}
				nl = (int)(p - tp->val);
				p1 = (char *)net_malloc(nl + strlen(new) + 1);
				strncpy(p1, tp->val, nl);
				strcpy(p1 + nl, new);
			}
			net_free(tp->val);
			tp->val = p1;
#ifdef	DEBUG
			printf("to <%s\n>", p1);
#endif
		}
	}
}

/* setting route */
static void
sm_route(head, host, mailer, domain)
struct list **head;
char	*host;
char	*mailer;
char	*domain;
{
struct list *tp;
int	n;
	for(tp = *head; tp != NULLLIST; tp = tp->next) {
		if (tp->dom == 256)
			continue;
		if ((n = sm_chkdom(tp->val, domain)) > 0) {
			if (tp->dom > n)
				continue;
			tp->dom = n;
			if (tp->host != NULL) {
				net_free(tp->host);
				tp->host = NULL;
			}
			tp->host = (char *)net_malloc(strlen(host)+1);
			strcpy(tp->host, host);
			tp->type = DOMAIN;
#ifdef	UUCP
			if (strcmp(mailer, "uucp") == 0)
				tp->mailer = MAIL_UUCP;
			else
#endif
#ifdef	RMAIL
			if (strcmp(mailer, "rmail") == 0)
				tp->mailer = MAIL_RMAIL;
			else
#endif
				tp->mailer = MAIL_SMTP;
#ifdef	DEBUG
			printf("route <%s> to <%s>\n", tp->val,host);
#endif
		}
	}
}

static int
sm_chkdom(s1,s2)
char *s1;
char *s2;
{
char	*p;
char	*cp;
int	n;
	p = strrchr(s1,'@');
	if (p == NULL)
		return -1;	/* not '@' address */
	++p;
	/* countup '.' */
	cp = p;
	n = 1;
	while(*cp) {
		if (*cp == '.')
			++n;
		++cp;
	}
	if (strcmp(p, s2) == 0)
		return n;
	while((p = strchr(p, '.')) != NULL) {
		++p;
		--n;
		if (strcmp(p,s2) == 0)
			return n;
	}
	return -1;
}


#ifdef KA9QMAIL
int 
#else
static int
#endif
mailhost(dest)
char	*dest;
{
struct MYDOM *mp;
	for (mp = myhost; mp != NULL_MYDOM; mp = mp->next) {
		if (strcmp(mp->domain, dest) == 0)
			return LOCAL;
	}
	return DOMAIN;
}

/* convert (list) -> (gateway) */
struct gateway *
conv_list(head)
struct list *head;
{
struct list *tp;
struct gateway *gp;
struct gateway *gtop;
struct address *ap;
	gtop = (struct gateway *)NULL;
	for(tp = head; tp != NULLLIST; tp = tp->next) {
		/* checking host entry */
		for (gp = gtop; gp; gp = gp->next) {
			if (tp->host == NULL && gp->name == NULL)
				break;	/* local */
			else if (tp->host == NULL || gp->name == NULL)
				continue;	/* not match */
			else {
				if (!strcmp(gp->name, tp->host))
					break;
			}
		}
		if (gp == (struct gateway *)NULL) {
			/* add host entry */
			gp = (struct gateway *)net_malloc(
					sizeof(struct gateway));
			if (tp->host != NULL) {
				gp->name = (char *)net_malloc(
					strlen(tp->host) +1);
				strcpy(gp->name, tp->host);
			}
			else
				gp->name = NULL;
			gp->addr = (struct address *)NULL;
			gp->mailer = tp->mailer;
			gp->next = gtop;
			gtop = gp;
		}
		for (ap = gp->addr; ap; ap = ap->next) {
			if (!strcmp(ap->name, tp->val))
				break;
		}
		if (ap == (struct address *)NULL) {
			ap = (struct address *)net_malloc(
					sizeof(struct address));
			ap->name = (char *)net_malloc(strlen(tp->val)+1);
			strcpy(ap->name, tp->val);
			ap->next = gp->addr;
			gp->addr = ap;
		}
	}
	return(gtop);
}

#ifdef	STANDALONE
void	del_list(lp)
struct list *lp;
{
	register struct list *tp, *tp1;
	for (tp = lp; tp != NULLLIST; tp = tp1) {
		tp1 = tp->next;
		if (tp->val != NULLCHAR)
			net_free(tp->val);
		if (tp->host != NULLCHAR)
			net_free(tp->host);
		net_free((char *)tp);
	}
}

static void
rip(s)
register char	*s;
{
	register char	*cp;
	if ((cp = index(s, '\r')) != NULLCHAR)
		*cp = 0;
	if ((cp = index(s, '\n')) != NULLCHAR)
		*cp = 0;
}
#endif

#ifndef	OIMO
free_sendlist(gp)
struct gateway *gp;
{
struct gateway *gate, *gate2;
struct address *p, *q;
	for(gate = gp ; gate; gate = gate2) {
		for (p = gate->addr; p; p = q) {
			q = p->next;
			if (p->name != NULL)
				net_free(p->name);
			net_free(p);
		}
		gate2 = gate->next;
		if (gate->name != NULL)
			net_free(gate->name);
		net_free(gate);
	}
	return 0;
}

#endif

#endif

