/* mails.c	(C) 1992 taka@exsys.prm.prug.or.jp
	display mail queue */

/* Rev. for MS-DOS(MSC)  18/Feb.1992  M.Satoh(JA2JMK) */ 
/*	please set -DMSC on compiler option */

/* update:
	920918:	argv change. argv = hotname
	930202: -q add. argv search change.
*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>

#ifdef MSC
#include <dos.h>
#include <malloc.h>
#define	MQUEUE_DIR	"\\spool\\mqueue"
#define	LINELEN		256
#else
#include <dirent.h>
#endif
#include "defs.h"

int	sum = 0;
int	list = 0;
int	hosts = 0;
char	*mqdir = MQUEUE_DIR;
char	*host = NULL;

/* summry structer */
struct SUM_LIST {
	struct SUM_LIST	*next;
	char	*to;
	long	size;
	int	count;
};

#define NULLSUM	(struct SUM_LIST *)0

struct SUM_LIST	*s_top = NULLSUM;
struct SUM_LIST *h_top = NULLSUM;

main(argc,argv)
int	argc;
char	**argv;
{
char	**av;
char	*p;
	/* check argument */
	av = argv;
	while((p = *++av) != NULL) {
		if (*p != '-')
			break;
		++p;
		while(*p) {
			switch(*p++) {

			case 's' :	/* sumary */
				++sum;
				break;
			case 'l' :	/* long */
				++list;
				break;
			case 'q' :
				++hosts;
				break;
			default :
				fprintf(stderr, "%s: Invalid argument\n",
					argv[0]);
			case 'h' :
				usage(argv[0]);
				exit(0);
			}
		}
	}
	if (*av != NULL)
		host = *av;
	if (sum == 0 && list == 0 && hosts == 0) {
		++sum;
		++list;
	}
	disp_list();
	exit(0);
}

/* print usage */
usage(prg)
char	*prg;
{
	fprintf(stderr, "Display mail queue  %s\n",VERSION);
	fprintf(stderr, "Usage: %s [-s] [-l] [-h] [-q] [host]\n",prg);
	fprintf(stderr, "\t-s\tsumary\n");
	fprintf(stderr, "\t-l\tlist\n");
	fprintf(stderr, "\t-h\tHelp display\n");
	fprintf(stderr, "\t-q\tHosts\n");
	fprintf(stderr, "\thost\thostname\n");
	fprintf(stderr, "Default: list and sumary.\n");
}

/* display list */
disp_list()
{
char	buf[LINELEN];
char	buf1[3][LINELEN];
struct stat	sbuf;
#ifdef MSC
struct	find_t	finf;
#else
DIR	*dp;
struct dirent	*d;
#endif
FILE    *fp;
FILE	*fp1;
int     i;
char    *p;
char    flag;
int     count;
int	size;
int	err;

#ifdef	MSC
	sprintf(buf,"%s\\*.wrk",mqdir);
	if( _dos_findfirst(buf,_A_NORMAL,&finf) != 0 ) {
		printf("No jobs queueing\n");
		exit(0);
	}
#else
	if ((dp = opendir(mqdir)) == NULL) {
		fprintf(stderr, "Can't open mqueue\n");
		exit(0);
	}
#endif
	/* countup */
	count = 0;
#ifdef	MSC
	while(1) {
		sprintf(buf,"%s\\%s",mqdir,finf.name);
#else
	while((d = readdir(dp)) != NULL) {
		/* skip '.' /  '..' */
		if (d->d_name[0] == '.')
			continue;
		if ((p = strchr(d->d_name, '.')) == NULL)
			continue;
		if (strcmp(p+1, "wrk") != 0)
			continue;
		sprintf(buf,"%s/%s", mqdir, d->d_name);
#endif
		/* open wrk file */
		if ((fp1 = fopen(buf,"r")) == NULL) {
			continue;
		}
		/* reading */
		err = 0;
		for(i = 0; i < 2; i++) {
			if (fgets(buf1[i],LINELEN,fp1) == NULL) {
				if (err > 10) {
					fprintf(stderr,"%s format error\n",buf);
					break;
				}
				else {
					++err;
					fseek(fp1, 0, 0L);
					i = -1;
					continue;
				}
			}
			rip(buf1[i]);
		}
		if (i != 2) {
			fclose(fp1);
			continue;
		}
		if (host != NULL) {
			if (strcmp(host, buf1[0]) != 0) {
				fclose(fp1);
				continue;
			}
		}
		/* get stat *.txt */
		p = strchr(buf,'.');
		strcpy(p+1,"txt");
		if (stat(buf,&sbuf) == -1) {
			fclose(fp1);
			continue;
		}
		size = sbuf.st_size;
		/* check *.lck file */
		strcpy(p+1,"lck");
		if ((fp = fopen(buf, "r")) != NULL) {
			fclose(fp);
			flag = '*';
		}
		else
			flag = ' ';
		*p = 0;
#ifdef	MSC
		p = strrchr(buf,'\\');
#else
		p = strrchr(buf,'/');
#endif
		/* list display */
		if (list) {
			printf("%s%c\tSize: %ld\tToHost: %s\n",
				p+1, flag, sbuf.st_size, buf1[0]);
			printf("\tFrom: %s\n",buf1[1]);
		}
		if (hosts)
			make_host(sbuf.st_size, buf1[0]);
		while(fgets(buf1[2], 256,fp1) != NULL) {
			rip(buf1[2]);
			if (list) {
				printf("\tTo:   %s\n",buf1[2]);
			}
			if (sum)
				make_sum(sbuf.st_size, buf1[2]);
		}
		fclose(fp1);
		++count;

#ifdef MSC
		if( _dos_findnext(&finf) != 0 )
			break;;
#endif
	}
#ifndef MSC
	closedir(dp);
#endif
	/* sum display */
	if (sum)
		disp_sum();
	if (hosts)
		disp_host();
	printf("\n");
	printf("Total %d jobs queueing\n",count);
}

/* print summary */
disp_sum()
{
struct SUM_LIST	*s;
	if (s_top == NULLSUM)
		return(0);
	printf("\n");
	for(s = s_top; s != NULLSUM; s = s->next) {
		printf("To: %-30s\tCount: %d\tSize: %ld\n",
			s->to, s->count, s->size);
	}
}

/* print host */
disp_host()
{
struct SUM_LIST *s;
        if (h_top == NULLSUM)
                return(0);
        printf("\n");
        for(s = h_top; s != NULLSUM; s = s->next) {
                printf("Host: %-30s\tCount: %d\tSize: %ld\n",
                        s->to, s->count, s->size);
        }
}

/* make summary list */
make_sum(size, list)
long	size;
char	*list;
{
struct SUM_LIST	*s;
char	*p;
	if (s_top != NULLSUM) {
		for(s = s_top; s != NULLSUM; s = s->next) {
			if (strcmp(list, s->to) != 0)
				continue;
			s->size += size;
			++s->count;
			return(0);
		}
	}
	/* setup structer */
	s = (struct SUM_LIST *) malloc(sizeof(struct SUM_LIST));
	p = (char *)malloc(strlen(list) +1);
	strcpy(p, list);
	s->to = p;
	s->size = size;
	s->count = 1;
	/* link */
	s->next = s_top;
	s_top = s;
}

make_host(size, list)
long    size;
char    *list;
{
struct SUM_LIST *s;
char    *p;
        if (h_top != NULLSUM) {
                for(s = h_top; s != NULLSUM; s = s->next) {
                        if (strcmp(list, s->to) != 0)
                                continue;
                        s->size += size;
                        ++s->count;
                        return(0);
                }
        }
        /* setup structer */
        s = (struct SUM_LIST *) malloc(sizeof(struct SUM_LIST));
        p = (char *)malloc(strlen(list) +1);
        strcpy(p, list);
        s->to = p;
        s->size = size;
        s->count = 1;
        /* link */
        s->next = h_top;
        h_top = s;
}

/* strip cr/lf */
rip(s)
char *s;
{
	while(*s) {
		if (*s == '\r' || *s == '\n')
			*s = 0;
		++s;
	}
}
