/* mqdu.c	(C) 1993 taka@exsys.prm.prug.or.jp
	display mail queue size */

/* update:
*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <dirent.h>
#include "defs.h"

char	*mqdir = MQUEUE_DIR;

main(argc,argv)
int	argc;
char	**argv;
{
char	buf[LINELEN];
char	buf1[LINELEN];
struct stat	sbuf;
DIR	*dp;
struct dirent	*d;
FILE    *fp;
char	to[LINELEN];
long	size;
char	*p;
int	i;
int err;
	/* check argument */
	if (argc != 2) {
		fprintf(stderr, "Usage: %s rmt.cmd/user@site\n", argv[0]);
		exit(0);
	}
	if (strchr(argv[1], '@') != NULL) {
		/* '@' is arrive. argv is to-address */
		strcpy(to, argv[1]);
	}
	else {
		/* get to address from rmt.cmd */
		if ((fp = fopen(argv[1], "r")) == NULL) {
			fprintf(stderr, "%s not found\n", argv[1]);
			exit(0);
		}
		fgets(buf,LINELEN, fp);
		rip(buf);
		to[0] = 0;
		sscanf(buf, "%*s %s", to);
		fclose(fp);
	}
	/* search mqueue */
	if ((dp = opendir(mqdir)) == NULL) {
		fprintf(stderr, "Can't open mqueue\n");
		exit(0);
	}
	/* countup */
	size = 0;
	while((d = readdir(dp)) != NULL) {
		/* skip '.' /  '..' */
		if (d->d_name[0] == '.')
			continue;
		if ((p = strchr(d->d_name, '.')) == NULL)
			continue;
		if (strcmp(p+1, "wrk") != 0)
			continue;
		sprintf(buf,"%s/%s", mqdir, d->d_name);
		/* open wrk file */
		if ((fp = fopen(buf,"r")) == NULL) {
			fprintf(stderr,"%s open error\n", buf);
			continue;
		}
		/* reading */
		err = 0;
		for(i = 0; i < 3; i++) {
			if (fgets(buf1,LINELEN,fp) == NULL) {
				if ( err > 10) {
					fprintf(stderr,"%s format error\n",buf);
					break;
				}
				else {
					++err;
					fseek(fp, 0, 0L);
					i = -1;
					continue;
				}
			}
		}
		fclose(fp);
		if (i != 3)
			continue;
		rip(buf1);
		if (strcmp(buf1, to) != 0)
			continue;
		/* get stat *.txt */
		p = strchr(buf,'.');
		strcpy(p+1,"txt");
		if (stat(buf,&sbuf) == -1) {
			fprintf(stderr,"%s stat error\n",buf);
			continue;
		}
		size += sbuf.st_size;

	}
	closedir(dp);
	/* sum display */
	printf("%d\n", size);
	exit(0);
}

/* strip cr/lf */
rip(s)
char *s;
{
	while(*s) {
		if (*s == '\r' || *s == '\n')
			*s = 0;
		++s;
	}
}
